'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.oop = exports.registerRulesForLanguage = exports.AVAILABLE_LANGUAGES = exports.DocCommentHighlightRules = exports.TextHighlightRules = exports.Tokenizer = undefined;

var _tmTokenizer = require('./ace/tmTokenizer');

Object.defineProperty(exports, 'Tokenizer', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_tmTokenizer).default;
  }
});

var _text_highlight_rules = require('./ace/text_highlight_rules');

Object.defineProperty(exports, 'TextHighlightRules', {
  enumerable: true,
  get: function get() {
    return _text_highlight_rules.TextHighlightRules;
  }
});

var _doc_comment_highlight_rules = require('./ace/doc_comment_highlight_rules');

Object.defineProperty(exports, 'DocCommentHighlightRules', {
  enumerable: true,
  get: function get() {
    return _doc_comment_highlight_rules.DocCommentHighlightRules;
  }
});

var _languages = require('./languages');

Object.defineProperty(exports, 'AVAILABLE_LANGUAGES', {
  enumerable: true,
  get: function get() {
    return _languages.AVAILABLE_LANGUAGES;
  }
});
Object.defineProperty(exports, 'registerRulesForLanguage', {
  enumerable: true,
  get: function get() {
    return _languages.registerRulesForLanguage;
  }
});

var _oop = require('./ace/oop');

var oop = _interopRequireWildcard(_oop);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.oop = oop;