'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AVAILABLE_LANGUAGES = exports.State = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.registerRulesForLanguage = registerRulesForLanguage;

var _monacoEditor = require('monaco-editor');

var monaco = _interopRequireWildcard(_monacoEditor);

var _tmTokenizer = require('./ace/tmTokenizer');

var _tmTokenizer2 = _interopRequireDefault(_tmTokenizer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var State = exports.State = function () {
  function State(state) {
    _classCallCheck(this, State);

    this.state = state;
  }

  _createClass(State, [{
    key: 'equals',
    value: function equals(other) {
      return other === this || other.state === this.state;
    }
  }, {
    key: 'clone',
    value: function clone() {
      return new State(this.state);
    }
  }]);

  return State;
}();

var AVAILABLE_LANGUAGES = exports.AVAILABLE_LANGUAGES = ["ada", "clojure", "cobol", "d", "elixir", "erlang", "fortran", "groovy", "haskell", "julia", "kotlin", "ocaml", "pascal", "perl", "racket", "sbcl", "scala", "tcl", "vue"];

function registerRulesForLanguage(languageId, highlightRules) {
  var tokenizer = new _tmTokenizer2.default(highlightRules.getRules());
  return monaco.languages.setTokensProvider(languageId, {
    getInitialState: function getInitialState() {
      return new State('');
    },
    tokenize: function tokenize(line, startState) {
      var _tokenizer$getLineTok = tokenizer.getLineTokens(line, startState.state),
          tokens = _tokenizer$getLineTok.tokens,
          state = _tokenizer$getLineTok.state;

      var offset = 0;

      var monacoTokens = tokens.map(function (token) {
        var tok = {
          startIndex: offset,
          scopes: token.type
        };

        offset += token.value.length;

        return tok;
      });

      return {
        endState: new State(state),
        tokens: monacoTokens
      };
    }
  });
}